Lua_ChampionshipRewardWindow = class("Lua_ChampionshipRewardWindow", Lua_Window)
function Lua_ChampionshipRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipRewardWindow";
	self.skinName = "ChampionshipRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnInfo = Array();
	self.btnInfo:add(540022);
	self.btnInfo:add(540023);

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.buttonList:setLocation(0, -439, 0);
	self.buttonList:setButtonCell(Lua_CommonButtonItem2);
	self.buttonList:setButtonItem(160, 67);
	self.buttonList:setClickCallBack(self, self.onButtonClick);
	self.buttonList:setData(self.btnInfo);

	self.itemList = Lua_DragList.new(self.content, 630, 635, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -55, 0);
	self.itemList:setListCell(Lua_ChampionshipRewardItem, 630, 120, 1);
	self.itemList:setCellSpacing(0, 5);
end

function Lua_ChampionshipRewardWindow:dispose()
	if self.buttonList then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.btnInfo then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipRewardWindow:showWin(param)
	self:superCall("showWin", param);
	self.buttonList:setSelected(param);
end

function Lua_ChampionshipRewardWindow:onButtonClick(index, data)
	local arr;
	if index == 1 then
		arr = DataCenter.championshipUtil:getRankRewardArr();
		self.levelText:setLangValue(540026);
		self.levelText:setLocation(-251.5, 295, 0);
	else
		arr = DataCenter.championshipUtil:getLevelRewardArr();
		self.levelText:setLangValue(540025);
		self.levelText:setLocation(-215, 295, 0);
	end
	self.itemList:setArrayData(arr);
	self.itemList:moveToIndex(1, true);
	self.titleName:setLangValue(data);
end




















Lua_ChampionshipRewardItem = class("Lua_ChampionshipRewardItem", Lua_ListCell)
function Lua_ChampionshipRewardItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipRewardItem_skin");
end

function Lua_ChampionshipRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(-55, 0, 0);
	self.itemList.pivot = 1;
	self.itemList.scaleVal = 0.75;
end

function Lua_ChampionshipRewardItem:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipRewardItem:setData(data)
	if data.id == nil then -- 竞猜奖励
		self.rankIcon:setLocation(-215, 0, 0);
		self.rankIcon:setAltas("championship_1", data.icon_sprite);
		self.rankText:setEnable(true);
		self.rankText.fontSize = 24;
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFDE3");
		self.rankText.effectStyle = 0;
		self.rankText:setLocation(-215, 0, 0);
		self.rankText.text = LanUtil.formateStr(10054, tostring(data.guess_level));
		self.itemList:setArrayData(data.reward_item);
	else -- 排名奖励
		self.rankIcon:setLocation(-256.5, 1.5, 0);
		if data.rank_range[1] <= 3 then
			self.rankIcon:setAltas("common_altas_4", "xui_jys_label_1"..(data.rank_range[1] - 1));
			self.rankText:setEnable(false);
		else
			self.rankIcon:setAltas("common_altas_4", "xui_jys_label_13");
			self.rankText:setEnable(true);
			self.rankText.fontSize = 30;
			self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
			self.rankText.effectStyle = 2;
			self.rankText.effectColorStr = Lua_ColorDefine.transColor("3E3B44");
			self.rankText:setEffectDistance(2, 2);
			self.rankText:setLocation(-256.5, 1.5, 0);
			if data.rank_range[1] == data.rank_range[2] then
				self.rankText.text = data.rank_range[1];
			else
				self.rankText.text = LanUtil.formateStr(10052, tostring(data.rank_range[1]), tostring(data.rank_range[2]));
			end
			self.rankText.fontSize = data.font_size;
		end

		local config = Lua_RewardConfigData.getConfigDataById(data.reward_id);
		self.itemList:setArrayData(config.client_show);
	end
	self.rankIcon:resetSize();
end

function Lua_ChampionshipRewardItem:onPressClick()
	self.itemList:onBoundClick();
end