Lua_ChampionshipRolePanel = class("Lua_ChampionshipRolePanel", Lua_DisplayObject)
function Lua_ChampionshipRolePanel:ctor(p)
	self:superCall("ctor", p, "ChampionshipRolePanel_skin");
end

function Lua_ChampionshipRolePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftPanel:setLocation(-210, 11.5, 0);
	self.leftPanel:setLayout(1, 0);
	self.leftPanel:setGridCell(70, 70, Lua_ChampionshipRoleHeroGridItem);
	self.leftPanel:setCanClick(true);

	self.rightPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightPanel:setLocation(210, 11.5, 0);
	self.rightPanel:setLayout(1, 0);
	self.rightPanel:setGridCell(70, 70, Lua_ChampionshipRoleHeroGridItem);
	self.rightPanel:setCanClick(true);

	self.leftForce = Lua_NumberImage.new(self.content);
	self.leftForce:setLocation(-299, -150, 0);
	self.leftForce.pivot = 1;
	self.leftForce.numOffsetX = -3;
	self.leftForce.numAtlas = "number";
	self.leftForce.preStr = "xui_zl1_number_0";

	self.rightForce = Lua_NumberImage.new(self.content);
	self.rightForce:setLocation(337, -150, 0);
	self.rightForce.pivot = -1;
	self.rightForce.numOffsetX = -3;
	self.rightForce.numAtlas = "number";
	self.rightForce.preStr = "xui_zl1_number_0";

	self.checkFight:addClickFuntion(self, self.onCheckFight);
end

function Lua_ChampionshipRolePanel:dispose()
	self:stopTimer();
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	if self.rightPanel ~= nil then
		self.rightPanel:dispose();
		self.rightPanel = nil;
	end
	if self.leftForce ~= nil then
		self.leftForce:dispose();
		self.leftForce = nil;
	end
	if self.rightForce ~= nil then
		self.rightForce:dispose();
		self.rightForce = nil;
	end
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipRolePanel:setCallBack(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_ChampionshipRolePanel:setRoleInfo(att_role, def_role, winId)
	if att_role == nil or tonumber(att_role.show_role.id) <= 0 then
		self.left_name.text = nil;
		self.left_integral.text = nil;
		self.icon_1:setEnable(false);
		self.leftPanel:setRoleId(nil);
		self.leftPanel:setDataByProto2(nil);
		self.leftForce.num = nil;
	else
		local role = att_role.show_role
		if DataCenter.roleData:isSameServer(role.server_prev) then
			self.left_name.text = role.name;
		else
			self.left_name.text = LanUtil.formateStr(10051, role.server_prev, role.name);
		end
		self.left_integral.text = LanUtil.formateStr(540028, att_role.score);
		self.icon_1:setEnable(true);
		self.leftPanel:setRoleId(1);
		self.leftPanel:setDataByProto2(att_role.line_up_info);
		self.leftForce.num = role.force;
	end

	if def_role == nil or tonumber(def_role.show_role.id) <= 0 then
		self.right_name.text = nil;
		self.right_integral.text = nil;
		self.icon_2:setEnable(false);
		self.rightPanel:setRoleId(nil);
		self.rightPanel:setDataByProto2(nil);
		self.rightForce.num = nil;
	else
		local role = def_role.show_role
		if DataCenter.roleData:isSameServer(role.server_prev) then
			self.right_name.text = role.name;
		else
			self.right_name.text = LanUtil.formateStr(10051, role.server_prev, role.name);
		end
		self.right_integral.text = LanUtil.formateStr(540028, def_role.score);
		self.icon_2:setEnable(true);
		self.rightPanel:setRoleId(1);
		self.rightPanel:setDataByProto2(def_role.line_up_info);
		self.rightForce.num = role.force;
		self.icon_2:setLocation(337 - self.rightForce.totalWidth - 20, -150, 0);
	end

	if winId == nil or tonumber(winId) == 0 then
		self.left_result:setEnable(false);
		self.right_result:setEnable(false);
	else
		self.left_result:setEnable(true);
		self.right_result:setEnable(true);
		if att_role == nil or tonumber(att_role.id) <= 0 then
			self.left_result:setAltas("common_altas_4", "xui_jys_label_2");
		else
			if att_role.id == winId then
				self.left_result:setAltas("common_altas_4", "xui_jys_label_1");
			else
				self.left_result:setAltas("common_altas_4", "xui_jys_label_2");
			end
		end
		if def_role == nil or tonumber(def_role.id) <= 0 then
			self.right_result:setAltas("common_altas_4", "xui_jys_label_2");
		else
			if def_role.id == winId then
				self.right_result:setAltas("common_altas_4", "xui_jys_label_1");
			else
				self.right_result:setAltas("common_altas_4", "xui_jys_label_2");
			end
		end
		self.left_result:resetSize();
		self.right_result:resetSize();
	end
end

function Lua_ChampionshipRolePanel:setStageInfo(info, recordId)
	self.scheduleText.text = DataCenter.championshipUtil:getScheduleStr(info.event_type, info.round)
	local serverTime = DataCenter.roleData.serverTime;
	if serverTime < tonumber(info.prepare_end_tick) then -- 准备阶段
		self.checkFight:setEnable(false);
		self.stageBg:setEnable(true);
		self.stageText:setEnable(true);
		self.timeText:setEnable(true);
		self.stageText:setLangValue(540033);
		self.endTime = tonumber(info.prepare_end_tick);
		self:startTimer();
		self:onTimer();
	elseif serverTime < tonumber(info.guress_end_tick) then -- 竞猜阶段
		self.checkFight:setEnable(false);
		self.stageBg:setEnable(true);
		self.stageText:setEnable(true);
		self.timeText:setEnable(true);
		self.stageText:setLangValue(540034);
		self.endTime = tonumber(info.guress_end_tick);
		self:startTimer();
		self:onTimer();
	elseif serverTime < tonumber(info.fight_end_tick) then -- 战斗阶段
		self.checkFight:setEnable(true);
		self.stageBg:setEnable(true);
		self.stageText:setEnable(true);
		self.timeText:setEnable(true);
		self.stageText:setLangValue(540035);
		self.endTime = tonumber(info.fight_end_tick);
		self:startTimer();
		self:onTimer();
	else
		self:stopTimer();
		self.checkFight:setEnable(false);
		self.stageBg:setEnable(false);
		self.stageText:setEnable(false);
		self.timeText:setEnable(false);
	end
	self.recordId = recordId;
end

function Lua_ChampionshipRolePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("GUESS_TIMER", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_ChampionshipRolePanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ChampionshipRolePanel:onTimer()
	local second = self.endTime - DataCenter.roleData.serverTime
	if second > 0 then
		self.timeText.text = Lua_TimeTransform.transSeconds6(second);
	else
		self:stopTimer();
		self.checkFight:setEnable(false);
		self.stageBg:setEnable(false);
		self.stageText:setEnable(false);
		self.timeText:setEnable(false);
		if self.owner and self.callBack then
			self.callBack(self.owner);
		end
	end
end

function Lua_ChampionshipRolePanel:onCheckFight(go)
	if self.recordId == nil then
		return;
	end
	if self.clickTime and getTime() - self.clickTime < 1 then
		return;
	end
	self.clickTime = getTime();
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.recordId);
end




















Lua_ChampionshipRoleHeroGridItem = class("Lua_ChampionshipRoleHeroGridItem", Lua_HeroGridViewItem)
function Lua_ChampionshipRoleHeroGridItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ChampionshipRoleHeroGridItem:buildShowItem()
	self:superCall("buildShowItem");
	self.bg:setAltas("common_altas_4", "xui_jys_widget_7");
	self.bg:SetDimensions(118, 118);
	self.bg:setScale(0.56, 0.56, 1);
end

function Lua_ChampionshipRoleHeroGridItem:setData(dataType, data)
	self:superCall("setData", dataType, data);
	if self.itemIcon then
		self.itemIcon:setScale(0.56, 0.56, 1);
	end
end