Lua_ChampionshipTopThreeWindow = class("Lua_ChampionshipTopThreeWindow", Lua_Window)
function Lua_ChampionshipTopThreeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipTopThreeWindow";
	self.skinName = "ChampionshipTopThreeWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipTopThreeWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ChampionshipTopThreeWindow:dispose()
	if self._avatarItem_1 then
		self._avatarItem_1:dispose()
		self._avatarItem_1 = nil
	end
	if self._avatarItem_2 then
		self._avatarItem_2:dispose()
		self._avatarItem_2 = nil
	end
	if self._avatarItem_3 then
		self._avatarItem_3:dispose()
		self._avatarItem_3 = nil
	end
	self:superCall("dispose");
end

function Lua_ChampionshipTopThreeWindow:showWin(param)
	self:superCall("showWin", param);
	self.timeText.text = LanUtil.formateStr(540024, Lua_TimeTransform.transSeconds8(param.last_start_tick));
	
	local nameStr;
	local serverStr;
	local avatarStr;
	local data;
	for i = 1, 3 do
		nameStr = "nameText_"..i;
		serverStr = "serverText_"..i;
		avatarStr = "avatarItem_"..i;
		self[nameStr]:setLangValue(202500);
		self[serverStr]:setEnable(false);
		data = param.role_list[i];
		if data then
			self[nameStr].text = data.show_role.name;

			-- if not strIsNullOrEmpty(data.show_role.server_prev) then
			-- 	self[serverStr]:setEnable(true);
			-- 	self[serverStr].text = LanUtil.formateStr(10047, data.show_role.server_prev);
			-- end

			self[avatarStr]:setRoleId(data.show_role.id, data.show_role.server_flag, data.is_robot);
			self[avatarStr]:setRoleDressUp(data.show_role.dress_info);
		end
	end
end

function Lua_ChampionshipTopThreeWindow.Get:avatarItem_1()
	if self._avatarItem_1 == nil then
		self._avatarItem_1 = Lua_AvatarItem.new(self.content)
		self._avatarItem_1:setLocation(3, 20, 0)
	end
	return self._avatarItem_1
end

function Lua_ChampionshipTopThreeWindow.Get:avatarItem_2()
	if self._avatarItem_2 == nil then
		self._avatarItem_2 = Lua_AvatarItem.new(self.content)
		self._avatarItem_2:setLocation(-237, 20, 0)
	end
	return self._avatarItem_2
end

function Lua_ChampionshipTopThreeWindow.Get:avatarItem_3()
	if self._avatarItem_3 == nil then
		self._avatarItem_3 = Lua_AvatarItem.new(self.content)
		self._avatarItem_3:setLocation(238, 20, 0)
	end
	return self._avatarItem_3
end