Lua_ChampionshipTurnOnWindow = class("Lua_ChampionshipTurnOnWindow", Lua_Window)
function Lua_ChampionshipTurnOnWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_ChampionshipTurnOnWindow"
	self.skinName = "ChampionshipTurnOnWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_ChampionshipTurnOnWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.btnGoto:addClickFuntion(self, self.onBtnGotoClick)

	self.attackAvatar = Lua_AvatarItem.new(self.content)
	self.attackAvatar:setLocation(-222, 195, 0)
	self.attackAvatar:setCanClick(true)

	self.defenseAvatar = Lua_AvatarItem.new(self.content)
	self.defenseAvatar:setLocation(222, 195, 0)
	self.defenseAvatar:setCanClick(true)

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(0, -212, 0);
	self.itemList.scaleVal = 0.86
	self.itemList.canClick = true
	self.itemList:setArrayData(DataCenter.championshipUtil.openShowReward)
end

function Lua_ChampionshipTurnOnWindow:dispose()
	if self.attackAvatar then
		self.attackAvatar:dispose()
		self.attackAvatar = nil
	end
	if self.defenseAvatar then
		self.defenseAvatar:dispose()
		self.defenseAvatar = nil
	end
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose")
end

function Lua_ChampionshipTurnOnWindow:showWin(param)
	self:superCall("showWin", param)

	local id = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, param.att_role.dress_info)
	local vo = DataCenter.roleUtil:getDressUpVoById(id)
	if vo == nil then
		self.attackTitle:setEnable(false)
	else
		self.attackTitle:setEnable(true)
		self.attackTitle:setAltas(vo.atlas, vo.sprite)
	end
	self.attackLevel.text = LanUtil.formateStr(10041, tostring(param.att_role.level))
	self.attackName.text = param.att_role.name
	self.attackScore.text = LanUtil.formateStr(540028, tostring(param.att_role.score))
	self.attackForce.text = param.att_role.force
	self.attackAvatar:setRoleId(param.att_role.role_id, nil, param.att_role.is_robot)
	self.attackAvatar:setRoleDressUp(param.att_role.dress_info)

	id = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_TITLE, param.def_role.dress_info)
	vo = DataCenter.roleUtil:getDressUpVoById(id)
	if vo == nil then
		self.defenseTitle:setEnable(false)
	else
		self.defenseTitle:setEnable(true)
		self.defenseTitle:setAltas(vo.atlas, vo.sprite)
	end
	self.defenseLevel.text = LanUtil.formateStr(10041, tostring(param.def_role.level))
	self.defenseName.text = param.def_role.name
	self.defenseScore.text = LanUtil.formateStr(540028, tostring(param.def_role.score))
	self.defenseForce.text = param.def_role.force
	self.defenseAvatar:setRoleId(param.def_role.role_id, nil, param.def_role.is_robot)
	self.defenseAvatar:setRoleDressUp(param.def_role.dress_info)
end

function Lua_ChampionshipTurnOnWindow:onBtnGotoClick(go)
	DataCenter.funcPathUtil:gotoFunction(1097, true)
end