-- 我的赛程
checkRequire("Lua_ChampionshipRolePanel");
checkRequire("Lua_ChampionshipRecordItem");
Lua_ChampionshipMySchedulePanel = class("Lua_ChampionshipMySchedulePanel", Lua_DisplayObject)
function Lua_ChampionshipMySchedulePanel:ctor(p)
	self:superCall("ctor", p, "ChampionshipMySchedulePanel_skin");
end

function Lua_ChampionshipMySchedulePanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("CHAMPIONSHIP_SCHEDULE_INFO", self, self.updateShowInfo);

	self.bg:SetDimensions(720, 1099 + self.adaptHeight);
	self.noneObject:SetActive(false);
	self.showObject:SetActive(false);
	self.btnLayOut:addClickFuntion(self, self.onBtnLayOutClick);

	self:onRequestInfo();
end

function Lua_ChampionshipMySchedulePanel:dispose()
	self:stopTimer();
	DataCenter.preLoadData:removeBySign("Lua_HeroLineupWindow", self, self.onSceneShow);
	if self.rolePanel ~= nil then
		self.rolePanel:dispose();
		self.rolePanel = nil;
	end
	if self.recordList then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipMySchedulePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.bg:SetDimensions(720, 1099 + adaptHeight);
	if self.recordList then
		self.recordList:setContentRect(720, 680 + adaptHeight);
	end
end

function Lua_ChampionshipMySchedulePanel:onRequestInfo()
	Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sScheduleInfo();
end

function Lua_ChampionshipMySchedulePanel:updateShowInfo()
	self:stopTimer();
	local data = DataCenter.championshipData;
	if data.stageInfo ~= nil and DataCenter.roleData:checkInTime(data.startTick, data.endTick) then
		if data.isEnter == 0 then
			self.noneObject:SetActive(true);
			self.showObject:SetActive(false);
			self:showTips(true);
			if data.stageInfo.event_type == 1 then
				self.titleText:setLangValue(540049);
			else
				self.titleText.text = LanUtil.formateStr(540029, DataCenter.championshipUtil:getScheduleStr(data.stageInfo.event_type, data.stageInfo.round));
			end
			self.timeText:setEnable(false);
			self.desText:setLangValue(540030);
		elseif data.isEnter == 1 then
			self.noneObject:SetActive(false);
			self.showObject:SetActive(true);
			self:showTips(false);
			if self.rolePanel == nil then
				self.rolePanel = Lua_ChampionshipRolePanel.new(self.showObject);
				self.rolePanel:setRectAnchor(1);
				self.rolePanel:setLocation(0, -322, 0);
				self.rolePanel:setCallBack(self, self.onRequestInfo);
			end
			self.rolePanel:setRoleInfo(data.attRole, data.defRole, data.winPlayerId);
			self.rolePanel:setStageInfo(data.stageInfo, data.fightRecordId)

			if data.matchRecordList == nil or #data.matchRecordList <= 0 then
				self:showRecordTips(true)
				if self.recordList then
					self.recordList:setEnable(false)
				end
			else
				self:showRecordTips(false)
				if self.recordList == nil then
					self.recordList = Lua_DragList.new(self.showObject, 720, 680 + self.adaptHeight, Lua_AxisDefine.Vertical);
					self.recordList:setLocation(0, -145, 0);
					self.recordList:setListCell(Lua_ChampionshipRecordItem, 720, 138, 1);
					self.recordList:setCellSpacing(0, 10);
				end
				self.recordList:setArrayData(data.matchRecordList)
				self.recordList.canDrag = not self.recordList.isTheEnd
			end
		end
	else
		self.noneObject:SetActive(true);
		self.showObject:SetActive(false);
		self:showTips(true);

		if DataCenter.championshipData.curRank >= DataCenter.championshipUtil.qualifiedContest then
			self.titleText:setLangValue(570082);
		else
			self.titleText:setLangValue(540049);
		end

		local second = DataCenter.championshipData.startTick - DataCenter.roleData.serverTime;
		if second > 0 then
			self.timeText:setEnable(true);
			self:startTimer();
			self:onTimer();
		else
			self.timeText:setEnable(false);
		end
		self.desText.text = LanUtil.formateStr(540031, tostring(data.arenaRank));
	end
end

function Lua_ChampionshipMySchedulePanel:showTips(value)
	if value then
		if self.noneBg == nil then
			self.noneBg = UICreate.createImage(self.noneObject, "/images/championship/xui_jys_widget_2.png", 0, 100, 0, 0)
			self.noneBg.siblingIndex = 0
			self.noneIcon = UICreate.createImage(self.noneObject, "/images/championship/xui_jys_bg_11.png", -7.5, 80, 0, 0)
			self.noneIcon.siblingIndex = 1
		end
		self.noneBg:setEnable(true)
		self.noneIcon:setEnable(true)
	else
		if self.noneBg then
			self.noneBg:setEnable(false)
			self.noneIcon:setEnable(false)
		end
	end
end

function Lua_ChampionshipMySchedulePanel:showRecordTips(value)
	if value then
		if self.noTipsIcon == nil then
			self.noTipsIcon = UICreate.createImage(self.showObject, "/images/common/xui_common_widget_020.png", 0, -145, 0, 0);

			self.noTipsText = UICreate.createLabel(self.showObject, nil, 0, -210, 100, 31, 40);
			self.noTipsText.pivotValue = 4;
			self.noTipsText.fontName = Lua_MyUISettings.huakangFontName;
			self.noTipsText.alignmentValue = 4;
			self.noTipsText.horizontalOverflowValue = 1;
			self.noTipsText.verticalOverflowValue = 1;
			self.noTipsText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noTipsText:setLangValue(540043);
		end
		self.noTipsIcon:setEnable(true);
		self.noTipsText:setEnable(true);
	else
		if self.noTipsIcon then
			self.noTipsIcon:setEnable(false);
			self.noTipsText:setEnable(false);
		end
	end
end

function Lua_ChampionshipMySchedulePanel:startTimer()
	if self.bTiming ~= true then
		self.bTiming = true;
		self:addTimer("Lua_ChampionshipMySchedulePanel", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_ChampionshipMySchedulePanel:stopTimer()
	if self.bTiming == true then
		self.bTiming = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ChampionshipMySchedulePanel:onTimer()
	local second = DataCenter.championshipData.startTick - DataCenter.roleData.serverTime;
	if second > 0 then
		self.timeText.text = LanUtil.formateStr(540032, Lua_TimeTransform.transSeconds20(second));
	else
		self:stopTimer();
		self.timeText:setEnable(false);
		self:onRequestInfo();
	end
end

function Lua_ChampionshipMySchedulePanel:onBtnLayOutClick(go)
	local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_CHAMPIONSHIP);
	DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end

function Lua_ChampionshipMySchedulePanel:onSceneShow(param)
	Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, Lua_HeroUtil.LINEUP_CHAMPIONSHIP);
end