Lua_ChampionshipRecordItem = class("Lua_ChampionshipRecordItem", Lua_ListCell);
function Lua_ChampionshipRecordItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipRecordItem_skin");
end

function Lua_ChampionshipRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem1 = Lua_AvatarItem.new(self.content);
	self.avatarItem1:setSiblingIndex(1);
	self.avatarItem1:setScale(0.7, 0.7, 0.7);
	self.avatarItem1:setLocation(-273.5, 7.5, 0);

	self.avatarItem2 = Lua_AvatarItem.new(self.content);
	self.avatarItem2:setSiblingIndex(1);
	self.avatarItem2:setScale(0.7, 0.7, 0.7);
	self.avatarItem2:setLocation(-96, 7.5, 0);
	
	self.checkData:addClickFuntion(self, self.onCheckData);
	self.checkVideo:addClickFuntion(self, self.onCheckVideo);
end

function Lua_ChampionshipRecordItem:dispose()
	if self.avatarItem1 ~= nil then
		self.avatarItem1:dispose();
		self.avatarItem1 = nil;
	end
	if self.avatarItem2 ~= nil then
		self.avatarItem2:dispose();
		self.avatarItem2 = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipRecordItem:setData(data)
	self.data = data;

	self.avatarItem1:setRoleId(data.att_role.id, data.att_role.server_flag, data.att_is_robot);
	self.avatarItem1:setRoleDressUp(data.att_role.dress_info);
	self.avatarItem1:setRoleLevel(data.att_role.level);
	if DataCenter.roleData:isSameServer(data.att_role.server_prev) then
		self.attName.text = data.att_role.name;
	else
		self.attName.text = LanUtil.formateStr(10051, data.att_role.server_prev, data.att_role.name);
	end

	self.avatarItem2:setRoleId(data.def_role.id, data.def_role.server_flag, data.def_is_robot);
	self.avatarItem2:setRoleDressUp(data.def_role.dress_info);
	self.avatarItem2:setRoleLevel(data.def_role.level);
	if DataCenter.roleData:isSameServer(data.def_role.server_prev) then
		self.defName.text = data.def_role.name;
	else
		self.defName.text = LanUtil.formateStr(10051, data.def_role.server_prev, data.def_role.name);
	end

	local str = DataCenter.championshipUtil:getScheduleStr(data.event_type, data.battle_round);
	if data.is_win == 2 then
		self.stageText.text = str;
		self.resultIcon:setEnable(false);
		self.resultText:setEnable(true);
		self.checkData:setEnable(false);
		self.checkVideo:setEnable(false);
	else
		if data.event_type == 3 then
			if data.battle_round == 1 then
				if DataCenter.roleData:isMyself(data.att_role.id) then
					if data.is_win == 1 then
						self.stageText:setLangValue(540037);
					else
						self.stageText.text = LanUtil.formateStr(540038, str);
					end
				else
					if data.is_win == 1 then
						self.stageText.text = LanUtil.formateStr(540038, str);
					else
						self.stageText:setLangValue(540037);
					end
				end
			else
				if DataCenter.roleData:isMyself(data.att_role.id) then
					if data.is_win == 1 then
						self.stageText.text = LanUtil.formateStr(540039, str);
					else
						self.stageText.text = LanUtil.formateStr(540040, str);
					end
				else
					if data.is_win == 1 then
						self.stageText.text = LanUtil.formateStr(540040, str);
					else
						self.stageText.text = LanUtil.formateStr(540039, str);
					end
				end
			end
		elseif data.event_type == 2 then
			if DataCenter.roleData:isMyself(data.att_role.id) then
				if data.is_win == 1 then
					self.stageText.text = LanUtil.formateStr(540041, str);
				else
					self.stageText.text = LanUtil.formateStr(540042, str);
				end
			else
				if data.is_win == 1 then
					self.stageText.text = LanUtil.formateStr(540042, str);
				else
					self.stageText.text = LanUtil.formateStr(540041, str);
				end
			end
		else
			self.stageText.text = str;
		end

		self.resultIcon:setEnable(true);
		if data.is_win == 1 then
			self.resultIcon:setLocation(-302.5, 34, 0);
		else
			self.resultIcon:setLocation(-68, 34, 0);
		end

		self.resultText:setEnable(false);
		self.checkData:setEnable(true);
		self.checkVideo:setEnable(true);
	end
end

function Lua_ChampionshipRecordItem:onCheckData(go)
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(self.data.fight_record_id);
end

function Lua_ChampionshipRecordItem:onCheckVideo(go)
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data.fight_record_id);
end