-- 我的竞猜
Lua_ChampionshipMyQuizWindow = class("Lua_ChampionshipMyQuizWindow", Lua_Window)
function Lua_ChampionshipMyQuizWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipMyQuizWindow";
	self.skinName = "ChampionshipMyQuizWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipMyQuizWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("CHAMPIONSHIP_QUIZ_RECORD_UPDATE", self, self.updateServerInfo);
	
	Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sQuizRecordInfo();
end

function Lua_ChampionshipMyQuizWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipMyQuizWindow:updateServerInfo(msg)
	if msg == nil or msg.guess_record_list == nil or #msg.guess_record_list <= 0 then
		self:showNone(true)
		if self.itemList then
			self.itemList:setEnable(false);
		end
	else
		self:showNone(false)
		if self.itemList == nil then
			self.itemList = Lua_DragList.new(self.content, 630, 720, Lua_AxisDefine.Vertical);
			self.itemList:setLocation(0, -63.5, 0);
			self.itemList:setListCell(Lua_ChampionshipMyQuizItem, 630, 148, 1);
		end
		self.itemList:setEnable(true);
		self.itemList:setArrayData(msg.guess_record_list);
	end
end

function Lua_ChampionshipMyQuizWindow:showNone(value)
	if value then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/championship/xui_jys_widget_18.png", 0, -65, 0, 0);

			self.noneText = UICreate.createLabel(self.content, nil, -7, -117.5, 100, 40, 40);
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noneText:setLangValue(540075);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end




















Lua_ChampionshipMyQuizItem = class("Lua_ChampionshipMyQuizItem", Lua_ListCell)
function Lua_ChampionshipMyQuizItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipMyQuizItem_skin");
end

function Lua_ChampionshipMyQuizItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem1 = Lua_AvatarItem.new(self.content);
	self.avatarItem1:setSiblingIndex(1);
	self.avatarItem1:setScale(0.7, 0.7, 0.7);
	self.avatarItem1:setLocation(-238, 13, 0);

	self.avatarItem2 = Lua_AvatarItem.new(self.content);
	self.avatarItem2:setSiblingIndex(1);
	self.avatarItem2:setScale(0.7, 0.7, 0.7);
	self.avatarItem2:setLocation(-77, 13, 0);

	self.resultItem = Lua_ConsumeIconItem.new(self.content);
	self.resultItem:setLocation(-11, -40, 0);
	self.resultItem .pivot = 1;
	self.resultItem:setStyle(Lua_MyUISettings.defaultFontName, 22, "5A452D");
	
	self.checkData:addClickFuntion(self, self.onCheckData);
	self.checkVideo:addClickFuntion(self, self.onCheckVideo);
end

function Lua_ChampionshipMyQuizItem:dispose()
	if self.avatarItem1 ~= nil then
		self.avatarItem1:dispose();
		self.avatarItem1 = nil;
	end
	if self.avatarItem2 ~= nil then
		self.avatarItem2:dispose();
		self.avatarItem2 = nil;
	end
	if self.resultItem then
		self.resultItem:dispose();
		self.resultItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipMyQuizItem:setData(data)
	self.data = data;
	self.stageText.text = DataCenter.championshipUtil:getScheduleStr(data.event_type, data.battle_round);

	self.avatarItem1:setRoleId(data.att_role.id, data.att_role.server_flag, data.att_is_robot);
	self.avatarItem1:setRoleDressUp(data.att_role.dress_info);
	self.avatarItem1:setRoleLevel(data.att_role.level);
	if DataCenter.roleData:isSameServer(data.att_role.server_prev) then
		self.attName.text = data.att_role.name;
	else
		self.attName.text = LanUtil.formateStr(10051, data.att_role.server_prev, data.att_role.name);
	end

	self.avatarItem2:setRoleId(data.def_role.id, data.def_role.server_flag, data.def_is_robot);
	self.avatarItem2:setRoleDressUp(data.def_role.dress_info);
	self.avatarItem2:setRoleLevel(data.def_role.level);
	if DataCenter.roleData:isSameServer(data.def_role.server_prev) then
		self.defName.text = data.def_role.name;
	else
		self.defName.text = LanUtil.formateStr(10051, data.def_role.server_prev, data.def_role.name);
	end

	if data.bet_player_id == data.att_role.id then
		self.resultText.text = LanUtil.formateStr(540061, data.att_role.name);
	else
		self.resultText.text = LanUtil.formateStr(540061, data.def_role.name);
	end
	if data.bet_result == 2 then
		self.resultIcon:setEnable(false);
		if data.bet_player_id == data.att_role.id then
			self.resultItem:setIcon("item_altas_1", "201000013", 35, 35, nil, Mathf.Abs(data.guess_coin_num));
		else
			self.resultItem:setIcon("item_altas_1", "201000013", 35, 35, nil, Mathf.Abs(data.guess_coin_num));
		end
	elseif data.bet_result == 1 then
		self.resultIcon:setEnable(true);
		if data.bet_player_id == data.att_role.id then
			self.resultIcon:setLocation(-267, 40, 0);
		else
			self.resultIcon:setLocation(-105, 40, 0);
		end
		self.resultItem:setIcon("item_altas_1", "201000013", 35, 35, LanUtil.getValue(540059), Lua_ColorDefine.getColorStr("459123", Mathf.Abs(data.guess_coin_num)));
	else
		self.resultIcon:setEnable(true);
		if data.bet_player_id == data.att_role.id then
			self.resultIcon:setLocation(-105, 40, 0);
		else
			self.resultIcon:setLocation(-267, 40, 0);
		end
		self.resultItem:setIcon("item_altas_1", "201000013", 35, 35, LanUtil.getValue(540060), Lua_ColorDefine.getColorStr("ED4B30", Mathf.Abs(data.guess_coin_num)));
	end

	if data.bet_result ~= 2 and tonumber(data.fight_record_id) > 0 then
		self.checkData:setEnable(true);
		self.checkVideo:setEnable(true);
		self.dataText:setEnable(true);
		self.videoText:setEnable(true);
	else
		self.checkData:setEnable(false);
		self.checkVideo:setEnable(false);
		self.dataText:setEnable(false);
		self.videoText:setEnable(false);
	end
end

function Lua_ChampionshipMyQuizItem:onCheckData(go)
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightHurtCollect(self.data.fight_record_id);
end

function Lua_ChampionshipMyQuizItem:onCheckVideo(go)
	if self.data == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data.fight_record_id);
end