-- 竞猜投注
Lua_ChampionshipQuizBettingWindow = class("Lua_ChampionshipQuizBettingWindow", Lua_Window)
function Lua_ChampionshipQuizBettingWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipQuizBettingWindow";
	self.skinName = "ChampionshipQuizBettingWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipQuizBettingWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.selectCount = 1;

	self.sliderBar = Lua_SliderProgressBar.new(self.content, 
		"common_altas_3", "xui_common_tipsprogress_004_b", "xui_common_tipsprogress_004_f", "xui_common_tipsprogress_004_m",
		250, 24, 0, 0);
	self.sliderBar:createLessPlus("common_altas_1", "xui_common_button_012", "xui_common_button_013", 25);
	self.sliderBar:createMinMax("common_altas_1", nil, "xui_common_button_014", 10);
	self.sliderBar:setLocation(-39, -15, 0);
	self.sliderBar:setValue(0, 0, 0);
	self.sliderBar:setCallBack(self, self.updateSelectCount);

	self.haveCount = Lua_ConsumeIconItem.new(self.content);
	self.haveCount:setLocation(-165.5, -70, 0);
	self.haveCount:setStyle(Lua_MyUISettings.defaultFontName, 26, "727663");

	self.costCount = Lua_ConsumeIconItem.new(self.content);
	self.costCount:setLocation(173.5, -70, 0);
	self.costCount:setStyle(Lua_MyUISettings.defaultFontName, 26, "727663");

	self.btnCancel:addClickFuntion(self, self.onCancelClick);
	self.btnConfirm:addClickFuntion(self, self.onConfirmClick);
end

function Lua_ChampionshipQuizBettingWindow:dispose()
	if self.sliderBar then
		self.sliderBar:dispose()
		self.sliderBar = nil
	end
	if self.haveCount then
		self.haveCount:dispose()
		self.haveCount = nil
	end
	if self.costCount then
		self.costCount:dispose()
		self.costCount = nil
	end
	self:superCall("dispose");
end

function Lua_ChampionshipQuizBettingWindow:showWin(param)
	self:superCall("showWin", param);

	self.nameText.text = LanUtil.formateStr(540054, param.role.show_role.name);
	
	self.coinId = DataCenter.championshipUtil.guessItemId;
	self.haveNum = DataCenter.packData:getItemCountById(self.coinId);

	local maxValue = DataCenter.championshipUtil.guessLimit;
	maxValue = self.haveNum > maxValue and maxValue or self.haveNum;
	self.sliderBar:setValue(self.selectCount, self.selectCount, maxValue);
	self.sliderBar:setTips(nil, LanUtil.formateStr(540055, tostring(maxValue)));

	self.haveCount:setIcon("item_altas_1", "201000013", 35, 35, LanUtil.getValue(540056), tostring(self.haveNum));

	self:updateSelectCount(self.selectCount);
end

function Lua_ChampionshipQuizBettingWindow:updateSelectCount(count)
	self.selectCount = count;
	self.coinCount.text = LanUtil.formateStr(540057, tostring(count));
	self.costCount:setIcon("item_altas_1", "201000013", 35, 35, LanUtil.getValue(540058), tostring(Mathf.Floor(count * self.showData.odds)));
end

function Lua_ChampionshipQuizBettingWindow:onCancelClick(go)
	self:hide();
end

function Lua_ChampionshipQuizBettingWindow:onConfirmClick(go)
	if self.haveNum < self.selectCount then
		DataCenter.packUtil:openPathWindow(self.coinId);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sQuizBetting(self.showData.role.show_role.id, self.selectCount);
end