-- 竞猜
checkRequire("Lua_ChampionshipRolePanel");
checkRequire("Lua_ChampionshipChatItem")
Lua_ChampionshipQuizPanel = class("Lua_ChampionshipQuizPanel", Lua_DisplayObject)
function Lua_ChampionshipQuizPanel:ctor(p)
	self:superCall("ctor", p, "ChampionshipQuizPanel_skin");
end

function Lua_ChampionshipQuizPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.isFirstEnter = true;
	self:addLuaEvent("CHAMPIONSHIP_QUIZ_INFO", self, self.updateServerInfo);
	self:addLuaEvent("CHAMPIONSHIP_QUIZ_BETTING_UPDATE", self, self.updateQuizBetting);
	self:addLuaEvent("CHAMPIONSHIP_QUIZ_RATE", self, self.updateQuizBettingRate);
	self:addLuaEvent("CHAMPIONSHIP_RED_ENVELOPE", self, self.updateEnvelopeState);
	self:addLuaEvent("MONEY_UPDATE", self, self.updateQuizCoin);

	self:addLuaEvent("ADD_CHAT_MSG", self, self.onChatUpdate);
	self:addLuaEvent("CHAT_STATIC_EMOJI_SELECT", self, self.onStaticEmojiSelected);
	self:addLuaEvent("CHAT_DYNAMIC_EMOJI_SELECT", self, self.onDynamicEmojiSelected);

	self.bg_1:SetDimensions(720, 994 + self.adaptHeight);
	self.showObject:SetActive(false);
	self.leftQuiz:addClickFuntion(self, self.onLeftQuiz);
	self.rightQuiz:addClickFuntion(self, self.onRightQuiz);
	self.checkRecord:addClickFuntion(self, self.onCheckRecord);
	self.checkEnvelope:addClickFuntion(self, self.onCheckEnvelope);
	self.checkTitle:addClickFuntion(self, self.onCheckTitle);

	self.titleRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.Championship_Quiz_Title)
	self.titleRedPoint:setRectAnchor(7)
	self.titleRedPoint:setLocation(325, 280)

	self.chatChannel = Lua_ChatData.CHANNEL_CHAMPIONSHIP;
	self.defaultText = LanUtil.getValue(540053);
	self.curInputLen = 0;
	self.sendLimit = Lua_ChatChannelData.getConfigDataById(self.chatChannel).num_limit;

	self.chatContainer = Lua_DragContainer.new(self.content, 720, 550 + self.adaptHeight, Lua_AxisDefine.Vertical, true);
	self.chatContainer:setSiblingIndex(2);
	self.chatContainer:setLocation(0, -220, 0);

	self.chatInput:setDefaultLangValue(540053);
	self.chatInput.text = nil;
	self.chatInput:onChange(self, self.onInputChange);
	self.btnEmoji:addClickFuntion(self, self.onEmojiClick);
	self.btnSend:addClickFuntion(self, self.onSendClick);
	
	DataCenter.chatData:setChannelNewMsgNum(self.chatChannel, 0);
	local arr = DataCenter.chatData:getChannelMsgList(self.chatChannel);
	self:updateChatList(arr);

	self:onRequestInfo();
end

function Lua_ChampionshipQuizPanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.onRequestInfo);
	self:stopRedEnvelopeTween();
	if self.titleRedPoint then
		self.titleRedPoint:dispose();
		self.titleRedPoint = nil;
	end
	if self.chatContainer then
		self.chatContainer:dispose();
		self.chatContainer = nil;
	end
	if self.rolePanel ~= nil then
		self.rolePanel:dispose();
		self.rolePanel = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipQuizPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.bg_1:SetDimensions(720, 994 + adaptHeight);
	self.chatContainer:setContentRect(720, 550 + adaptHeight);
end

function Lua_ChampionshipQuizPanel:onRequestInfo()
	Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sQuizInfo();
end

function Lua_ChampionshipQuizPanel:showTips(value)
	if value then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/championship/xui_jys_widget_18.png", 14.5, -304, 0, 0);
			self.noneIcon.anchorValue = 1;

			self.noneText = UICreate.createLabel(self.content, nil, 7.5, -355, 100, 31, 32);
			self.noneText.anchorValue = 1;
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.verticalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noneText:setLangValue(540047);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end

function Lua_ChampionshipQuizPanel:updateServerInfo(msg)
	self.data = msg;
	self.is_draw_red_pack = msg.is_draw_red_pack; -- 是否领取本轮红包 1已领取 0未领取

	Lua_CommonUtil.removeTimer(self, self.onRequestInfo);
	if DataCenter.roleData:checkInTime(msg.start_tick, msg.end_tick) then
		self.bg_2:setLocation(0, -513, 0);
		self.line_1:setEnable(true)
		self.showObject:SetActive(true);
		local serverTime = DataCenter.roleData.serverTime
		if serverTime < tonumber(msg.stage_info.prepare_end_tick) then -- 准备阶段
			self:showTips(true);
			if self.rolePanel then
				self.rolePanel:setEnable(false);
			end
			Lua_CommonUtil.delayCall(tonumber(msg.stage_info.prepare_end_tick) - serverTime, self, self.onRequestInfo)
			self:updateQuizRate(nil, nil, 1, 1)
		else
			self:showTips(false);
			if self.rolePanel == nil then
				self.rolePanel = Lua_ChampionshipRolePanel.new(self.showObject);
				self.rolePanel:setRectAnchor(1);
				self.rolePanel:setLocation(0, -322, 0);
				self.rolePanel:setCallBack(self, self.onRequestInfo);
			end
			self.rolePanel:setEnable(true);
			self.rolePanel:setRoleInfo(msg.role_list[1], msg.role_list[2], msg.win_player_id);
			self.rolePanel:setStageInfo(msg.stage_info, msg.fight_record_id);
			if self.isFirstEnter ~= true and serverTime >= tonumber(msg.stage_info.guress_end_tick) and serverTime < tonumber(msg.stage_info.fight_end_tick) then -- 战斗阶段
				Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(msg.fight_record_id);
				Lua_WindowUtil.openWin("Lua_ChampionshipQuizBettingWindow", Lua_WinParam.ACTION_CLOSE);
			end

			local value1 = 1;
			if #msg.role_list > 0 then
				value1 = msg.role_list[1].odds;
			end
			local value2 = 1;
			if #msg.role_list > 1 then
				value2 = msg.role_list[2].odds;
			end
			self:updateQuizRate(value1, value2, msg.bet_att_nums, msg.bet_def_nums);
		end

		self:updateQuizCoin();
		self:updateQuizState(msg.bet_id);
		self:updateEnvelopeState();
	else
		self:showTips(true);
		self.bg_2:setLocation(0, -659, 0);
		self.line_1:setEnable(false)
		self.showObject:SetActive(false);
	end

	self.isFirstEnter = false;
end

function Lua_ChampionshipQuizPanel:updateQuizCoin()
	self.coinCount.text = DataCenter.packData:getItemCountById(DataCenter.championshipUtil.guessItemId);
end

function Lua_ChampionshipQuizPanel:updateQuizBetting(msg)
	if msg == nil then
		return;
	end

	self:updateQuizCoin();
	self:updateQuizRate(msg.attack_odds, msg.defence_odds, msg.bet_att_nums, msg.bet_def_nums);
	self:updateQuizState(msg.bet_player_id);
end

function Lua_ChampionshipQuizPanel:updateQuizBettingRate(msg)
	if msg == nil then
		return;
	end
	
	self:updateQuizRate(msg.attack_odds, msg.defence_odds, msg.bet_att_nums, msg.bet_def_nums);
end

function Lua_ChampionshipQuizPanel:updateQuizRate(attack_odds, defence_odds, bet_att_nums, bet_def_nums)
	self.attack_odds = attack_odds;
	self.defence_odds = defence_odds;
	if attack_odds == nil or defence_odds == nil then
		self.leftRate:setEnable(false);
		self.rightRate:setEnable(false);
	else
		self.leftRate:setEnable(true);
		self.leftRate.text = LanUtil.formateStr(540051, string.format("%.2f", attack_odds));
		self.rightRate:setEnable(true);
		self.rightRate.text = LanUtil.formateStr(540051, string.format("%.2f", defence_odds));
	end

	local width = self.barBg.width
	local addH = 10
	local temp = width / 2 + addH
	if bet_att_nums == bet_def_nums then
		self.leftBar:SetDimensions(temp, 24)
		self.rightBar:SetDimensions(temp, 24)
		self.barText:setLangValue(540050)
	else
		-- print(bet_att_nums, bet_def_nums)
		local maxValue = bet_att_nums + bet_def_nums
		local value
		if bet_att_nums == 0 then
			self.leftBar:SetDimensions(0, 24)
			self.rightBar:SetDimensions(width, 24)
		elseif bet_def_nums == 0 then
			self.leftBar:SetDimensions(width, 24)
			self.rightBar:SetDimensions(0, 24)
		else
			local leftIdx = self.leftBar.siblingIndex
			local rightIdx = self.rightBar.siblingIndex
			if bet_att_nums > bet_def_nums then
				value = bet_att_nums / maxValue
				temp = width * value
				self.leftBar:SetDimensions(temp + addH, 24)
				self.leftBar.siblingIndex = rightIdx
				self.rightBar:SetDimensions(width - temp + addH, 24)
				self.rightBar.siblingIndex = leftIdx
			else
				value = bet_def_nums / maxValue
				temp = width * value
				self.leftBar:SetDimensions(width - temp + addH, 24)
				self.rightBar:SetDimensions(temp + addH, 24)
				if leftIdx > rightIdx then
					self.leftBar.siblingIndex = rightIdx
					self.rightBar.siblingIndex = leftIdx
				end
			end
		end
		if bet_att_nums > bet_def_nums then
			value = string.format("%.1f", bet_att_nums / maxValue)
		else
			value = string.format("%.1f", bet_def_nums / maxValue)
		end
		self.barText.text = LanUtil.formateStr(10053, tostring(tonumber(value * 100)));
	end
end

function Lua_ChampionshipQuizPanel:updateQuizState(id)
	if self.data == nil then
		return;
	end

	if tonumber(id) > 0 then
		self.leftQuiz.mouseEnable = false;
		self.rightQuiz.mouseEnable = false;
		if #self.data.role_list > 0 then
			if self.data.role_list[1].show_role.id == id then
				self.leftQuizText:setLangValue(570078);
				self.leftQuiz:setGray(false);
			else
				self.leftQuizText:setLangValue(540077);
				self.leftQuiz:setGray(true);
			end
		else
			self.leftQuizText:setLangValue(540077);
			self.leftQuiz:setGray(true);
		end
		if #self.data.role_list > 1 then
			if self.data.role_list[2].show_role.id == id then
				self.rightQuizText:setLangValue(570078);
				self.rightQuiz:setGray(false);
			else
				self.rightQuizText:setLangValue(540077);
				self.rightQuiz:setGray(true);
			end
		else
			self.rightQuizText:setLangValue(540077);
			self.rightQuiz:setGray(true);
		end
	else
		self.leftQuizText:setLangValue(540077);
		self.rightQuizText:setLangValue(540077);
		local serverTime = DataCenter.roleData.serverTime;
		local info = self.data.stage_info;
		if serverTime >= tonumber(info.prepare_end_tick) and serverTime < tonumber(info.guress_end_tick) then -- 竞猜阶段
			self.leftQuiz.mouseEnable = true;
			self.leftQuiz:setGray(false);
			self.rightQuiz.mouseEnable = true;
			self.rightQuiz:setGray(false);
		else
			self.leftQuiz.mouseEnable = false;
			self.leftQuiz:setGray(true);
			self.rightQuiz.mouseEnable = false;
			self.rightQuiz:setGray(true);
		end
	end
end

function Lua_ChampionshipQuizPanel:updateEnvelopeState(msg)
	if msg ~= nil then
		self.is_draw_red_pack = msg.is_draw_red_pack
	end
	if self.data.is_have_guess_red_pack == 1 and self.is_draw_red_pack == 0 then
		self.checkEnvelope:setEnable(true);
		self:startRedEnvelopeTween()
	else
		self:stopRedEnvelopeTween()
		self.checkEnvelope:setEnable(false);
	end
end

function Lua_ChampionshipQuizPanel:startRedEnvelopeTween()
	if self.bTween ~= true then
		self.bTween = true;
		Lua_CommonUtil.delayCall(DataCenter.championshipUtil.redEnvelopeTweenInterval, self, self.onRedEnvelopeTween)
	end
end

function Lua_ChampionshipQuizPanel:stopRedEnvelopeTween()
	if self.bTween == true then
		self.bTween = false;
		Lua_CommonUtil.removeTimer(self, self.onRedEnvelopeTween);
	end
	if self.tweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.tweenName);
	end
	self.tweenName = nil;
end

function Lua_ChampionshipQuizPanel:onRedEnvelopeTween()
	self:stopRedEnvelopeTween()
	self.tweenName = DataCenter.winTweenManager:createWinTween("Lua_ChampionshipQuizPanel_RedEnvelope", self.content.transform);
	self:startRedEnvelopeTween()
end

function Lua_ChampionshipQuizPanel:onLeftQuiz(go)
	if self.data and #self.data.role_list > 0 then
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizBettingWindow", Lua_WinParam.ACTION_OPEN, { role = self.data.role_list[1], odds = self.attack_odds });
	end
end

function Lua_ChampionshipQuizPanel:onRightQuiz(go)
	if self.data and #self.data.role_list > 1 then
		Lua_WindowUtil.openWin("Lua_ChampionshipQuizBettingWindow", Lua_WinParam.ACTION_OPEN, { role = self.data.role_list[2], odds = self.defence_odds });
	end
end

function Lua_ChampionshipQuizPanel:onCheckRecord(go)
	Lua_WindowUtil.openWin("Lua_ChampionshipMyQuizWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChampionshipQuizPanel:onCheckEnvelope(go)
	if self.data and self.is_draw_red_pack == 0 then
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sReceiveEnvelope();
		self.checkEnvelope:setEnable(false);
	else
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sEnvelopeInfo();
	end
end

function Lua_ChampionshipQuizPanel:onCheckTitle(go)
	Lua_WindowUtil.openWin("Lua_ChampionshipQuizTaskWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ChampionshipQuizPanel:updateChatList(chatList)
    self.chatContainer:clearList();
    local len = chatList:getSize();
    for i = 1, len do
        self.chatContainer:addSubContainer(Lua_ChampionshipChatItem, chatList[i]);
    end
    self.chatContainer:updateChildPos();
    self.chatContainer:moveToIndex(len, true);
end

function Lua_ChampionshipQuizPanel:onInputChange()
	local str = self.chatInput.text;
	local len = Lua_ChatUtil.calcInputTextLen(str);
    local validLen = len > self.sendLimit and self.curInputLen or len;
    if len > self.sendLimit then
        self.chatInput.text = self.prevTextContent;
    else
        self.curInputLen = validLen;
        self.prevTextContent = str;
    end
end

function Lua_ChampionshipQuizPanel:onChatUpdate(chatVo)
	if chatVo == nil or chatVo.channel ~= self.chatChannel then
		return;
	end

	local chatLimit = Lua_ChatChannelData.getConfigDataById(self.chatChannel).msg_limit;
	local chatLen = self.chatContainer.showDragDataList:getSize();
	if chatLen >= chatLimit then
		self.chatContainer:clearList();
		local arr = DataCenter.chatData:getChannelMsgList(self.chatChannel);
		for i = 1, arr:getSize() do
			self.chatContainer:addSubContainer(Lua_ChampionshipChatItem, arr[i], false);
		end
		self.chatContainer:updateChildPos();
	else
		self.chatContainer:addSubContainer(Lua_ChampionshipChatItem, chatVo, true);
	end
	self.chatContainer:moveToIndex(chatLen, true);
end

function Lua_ChampionshipQuizPanel:onStaticEmojiSelected(emojiId)
	local str = self.chatInput.text;
	if str == self.defaultText then
		str = LanUtil.formateStr(10044, "", tostring(emojiId));
	else
		str = LanUtil.formateStr(10044, str, tostring(emojiId));
	end
	if Lua_ChatUtil.calcInputTextLen(str) <= self.sendLimit then
		self.chatInput.text = str;
	else
		OperateAlert.showLangValue(171043);
	end
end

function Lua_ChampionshipQuizPanel:onDynamicEmojiSelected(emojiId)
    DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_DYNANIC_EMOJI, emojiId);
    Lua_ChatUtil.sendMsg(self.chatChannel, emojiId, false, false);
end

function Lua_ChampionshipQuizPanel:onEmojiClick(go)
	Lua_WindowUtil.openWin("Lua_ChatEmojiWindow", Lua_WinParam.ACTION_OPEN,{ pos = {58, -345 - self.adaptHeight / 2} });
end

function Lua_ChampionshipQuizPanel:onSendClick(go)
	local str = self.chatInput.text;
	if str == self.defaultText or utf8len(str) <= 0 then
		OperateAlert.showLangValue(171023);
		return;
	end
	Lua_ChatUtil.sendMsg(self.chatChannel, str, true, true);
	self.chatInput.text = nil;
end