-- 竞猜红包
Lua_ChampionshipQuizRedEnvelopeWindow = class("Lua_ChampionshipQuizRedEnvelopeWindow", Lua_Window)
function Lua_ChampionshipQuizRedEnvelopeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipQuizRedEnvelopeWindow";
	self.skinName = "ChampionshipQuizRedEnvelopeWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipQuizRedEnvelopeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setSiblingIndex(3);
	self.avatarItem:setLocation(0, 292, 0);

	self.itemList = Lua_DragList.new(self.content, 600, 610, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -130, 0);
	self.itemList:setListCell(Lua_ChampionshipQuizRedEnvelopeItem, 600, 128, 1);
	self.itemList:setCellSpacing(0, 5);
end

function Lua_ChampionshipQuizRedEnvelopeWindow:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipQuizRedEnvelopeWindow:showWin(param)
	self:superCall("showWin", param);

	self.avatarItem:setRoleAvatar(param.luck_player.head_id);
	self.avatarItem:setRoleFrame(param.luck_player.head_frame_id);
	self.avatarItem:setRoleLevel(param.luck_player.level);
	self.nameText.text = param.luck_player.name;
	self.resultIcon:setEnable(param.luck_player.is_luck_player == 1);
	self.coinCount.text = param.luck_player.draw_num;

	self.itemList:setArrayData(param.player_list);
end




















Lua_ChampionshipQuizRedEnvelopeItem = class("Lua_ChampionshipQuizRedEnvelopeItem", Lua_ListCell)
function Lua_ChampionshipQuizRedEnvelopeItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipQuizRedEnvelopeItem_skin");
end

function Lua_ChampionshipQuizRedEnvelopeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setScale(0.9, 0.9, 1);
	self.avatarItem:setLocation(-226, 0, 0);
end

function Lua_ChampionshipQuizRedEnvelopeItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipQuizRedEnvelopeItem:setData(data)
	self.avatarItem:setRoleId(data.player_id);
	self.avatarItem:setRoleAvatar(data.head_id);
	self.avatarItem:setRoleFrame(data.head_frame_id);
	self.avatarItem:setRoleLevel(data.level);
	if DataCenter.roleData:isMyself(data.player_id) then
		self.bg:setAltas("championship_2", "xui_jys_widget_23");
		self.nameText.colorStr = Lua_ColorDefine.transColor("C44437");
		self.nameText.text = LanUtil.formateStr(LanUtil.getValue(540062), data.name);
		self.countText.colorStr = Lua_ColorDefine.transColor("C44437");
	else
		self.bg:setAltas("championship_2", "xui_jys_widget_24");
		self.nameText.colorStr = Lua_ColorDefine.transColor("FFFFFF");
		self.nameText.text = data.name;
		self.countText.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	end
	self.resultIcon:setEnable(data.is_luck_player == 1);
	self.resultText:setEnable(data.is_luck_player == 1);
	self.timeText.text = os.date("%m-%d %H:%M:%S", data.draw_tick);
	self.countText.text = data.draw_num;
end