checkRequire("Lua_HeroLineupAureoleItem");
Lua_ChampionshipScheduleDetailsWindow = class("Lua_ChampionshipScheduleDetailsWindow", Lua_Window)
function Lua_ChampionshipScheduleDetailsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChampionshipScheduleDetailsWindow";
	self.skinName = "ChampionshipScheduleDetailsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ChampionshipScheduleDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.bg_1.clickScale = false;
	self.bg_1:addClickFuntion(self, self.onWinBgClick);
	self.bg_2.clickScale = false;
	self.bg_2:addClickFuntion(self, self.onWinBgClick);

	self.leftPanel = Lua_HeroGridViewPanel.new(self.content);
	self.leftPanel:setLocation(-200, 3, 0);
	self.leftPanel:setLayout(1, 2);
	self.leftPanel:setGridCell(78, 85, Lua_HeroGridViewItem2);
	self.leftPanel:setCanClick(true);
	self.leftPanel:setRoleId(1);

	self.rightPanel = Lua_HeroGridViewPanel.new(self.content);
	self.rightPanel:setLocation(200, 3, 0);
	self.rightPanel:setLayout(1, 0);
	self.rightPanel:setGridCell(78, 85, Lua_HeroGridViewItem2);
	self.rightPanel:setCanClick(true);
	self.rightPanel:setRoleId(1);

	self.leftForce = Lua_NumberImage.new(self.content);
	self.leftForce:setLocation(-299, -205, 0);
	self.leftForce.pivot = 1;
	self.leftForce.numOffsetX = -4;
	self.leftForce.numAtlas = "number";
	self.leftForce.preStr = "xui_zl1_number_0";

	self.rightForce = Lua_NumberImage.new(self.content);
	self.rightForce:setLocation(337, -205, 0);
	self.rightForce.pivot = -1;
	self.rightForce.numOffsetX = -4;
	self.rightForce.numAtlas = "number";
	self.rightForce.preStr = "xui_zl1_number_0";

	self.checkFight:addClickFuntion(self, self.onCheckFight);
end

function Lua_ChampionshipScheduleDetailsWindow:dispose()
	if self.leftPanel ~= nil then
		self.leftPanel:dispose();
		self.leftPanel = nil;
	end
	if self.rightPanel ~= nil then
		self.rightPanel:dispose();
		self.rightPanel = nil;
	end
	if self.leftForce ~= nil then
		self.leftForce:dispose();
		self.leftForce = nil;
	end
	if self.rightForce ~= nil then
		self.rightForce:dispose();
		self.rightForce = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipScheduleDetailsWindow:showWin(param)
	self:superCall("showWin", param);

	self.stageText.text = DataCenter.championshipUtil:getScheduleStr(param.event_type, param.round);
	self.checkFight:setEnable(tonumber(param.fight_record_id) > 0);

	local role;
	if param.attack_role == nil or tonumber(param.attack_role.show_role.id) <= 0 then
		self.leftName.text = nil;
		self.leftScore.text = nil;
		self.icon_1:setEnable(false);
		self.leftPanel:setDataByProto2(nil);
		self.leftForce.num = nil;
	else
		role = param.attack_role
		if DataCenter.roleData:isSameServer(role.show_role.server_prev) then
			self.leftName.text = role.show_role.name;
		else
			self.leftName.text = LanUtil.formateStr(10051, role.show_role.server_prev, role.show_role.name);
		end
		self.leftScore.text = LanUtil.formateStr(540028, role.score);
		self.icon_1:setEnable(true);
		self.leftPanel:setDataByProto2(role.line_up_info);
		self.leftForce.num = role.show_role.force;
	end

	if param.defence_role == nil or tonumber(param.defence_role.show_role.id) <= 0 then
		self.rightName.text = nil;
		self.rightScore.text = nil;
		self.icon_2:setEnable(false);
		self.rightPanel:setDataByProto2(nil);
		self.rightForce.num = nil;
	else
		role = param.defence_role
		if DataCenter.roleData:isSameServer(role.show_role.server_prev) then
			self.rightName.text = role.show_role.name;
		else
			self.rightName.text = LanUtil.formateStr(10051, role.show_role.server_prev, role.show_role.name);
		end
		self.rightScore.text = LanUtil.formateStr(540028, role.score);
		self.icon_2:setEnable(true);
		self.rightPanel:setDataByProto2(role.line_up_info);
		self.rightForce.num = role.show_role.force;
		self.icon_2:setLocation(337 - self.rightForce.totalWidth - 20, -205, 0);
	end

	if tonumber(param.win_player_id) == 0 then
		self.leftResult:setEnable(false);
		self.rightResult:setEnable(false);
	else
		self.leftResult:setEnable(true);
		self.rightResult:setEnable(true);
		if param.attack_role == nil or tonumber(param.attack_role.show_role.id) <= 0 then
			self.leftResult:setAltas("common_altas_4", "xui_jys_label_2");
		else
			if param.attack_role.show_role.id == param.win_player_id then
				self.leftResult:setAltas("common_altas_4", "xui_jys_label_1");
			else
				self.leftResult:setAltas("common_altas_4", "xui_jys_label_2");
			end
		end
		if param.defence_role == nil or tonumber(param.defence_role.show_role.id) <= 0 then
			self.rightResult:setAltas("common_altas_4", "xui_jys_label_2");
		else
			if param.defence_role.show_role.id == param.win_player_id then
				self.rightResult:setAltas("common_altas_4", "xui_jys_label_1");
			else
				self.rightResult:setAltas("common_altas_4", "xui_jys_label_2");
			end
		end
		self.leftResult:resetSize();
		self.rightResult:resetSize();
	end
end

function Lua_ChampionshipScheduleDetailsWindow:onCheckFight(go)
	if self.showData == nil then
		return;
	end
	if self.clickTime and getTime() - self.clickTime < 1 then
		return;
	end
	self.clickTime = getTime();
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.showData.fight_record_id);
end