Lua_ChampionshipScheduleItem = class("Lua_ChampionshipScheduleItem", Lua_DisplayObject)
function Lua_ChampionshipScheduleItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ChampionshipScheduleItem:buildShowItem()
	self:superCall("buildShowItem");
	self.line_1 = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.line_2 = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.avatarItem_1 = Lua_ChampionshipRoleAvatarItem.new(self.content);
	self.avatarItem_2 = Lua_ChampionshipRoleAvatarItem.new(self.content);
end

function Lua_ChampionshipScheduleItem:dispose()
	if self.avatarItem_1 then
		self.avatarItem_1:dispose();
		self.avatarItem_1 = nil;
	end
	if self.avatarItem_2 then
		self.avatarItem_2:dispose();
		self.avatarItem_2 = nil;
	end
	if self._firstAvatar then
		self._firstAvatar:dispose();
		self._firstAvatar = nil;
	end
	self:superCall("dispose");
end

function Lua_ChampionshipScheduleItem.Get:firstAvatar()
	if self._firstAvatar == nil then
		self._firstAvatar = Lua_ChampionshipRoleAvatarItem.new(self.content);
		self._firstAvatar:setLocation(0, -225, 0);
	end
	return self._firstAvatar;
end

function Lua_ChampionshipScheduleItem:setDefault(rank, style)
	self.rank = rank;
	self.style = style;
	self.avatarItem_1:setRank(self.rank);
	self.avatarItem_2:setRank(self.rank);
	if self._firstAvatar then
		self._firstAvatar:setEnable(false);
	end

	if self.style == 1 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_1:SetDimensions(65, 95);
		self.line_1:setScale(-1, 1, 1);
		self.line_1:setRot(0, 0, 0);
		self.line_1:setLocation(78.5, -35.5, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_2:SetDimensions(65, 95);
		self.line_2:setScale(-1, 1, 1);
		self.line_2:setRot(180, 0, 0);
		self.line_2:setLocation(78.5, -221, 0);

		self.avatarItem_2:setLocation(0, -256, 0);
	elseif self.style == 2 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_1:SetDimensions(65, 95);
		self.line_1:setScale(1, 1, 1);
		self.line_1:setRot(0, 0, 0);
		self.line_1:setLocation(-78.5, -35.5, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_2:SetDimensions(65, 95);
		self.line_2:setScale(1, 1, 1);
		self.line_2:setRot(180, 0, 0);
		self.line_2:setLocation(-78.5, -221, 0);

		self.avatarItem_2:setLocation(0, -256, 0);
	elseif self.style == 3 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
		self.line_1:SetDimensions(25, 85);
		self.line_1:setScale(1, 1, 1);
		self.line_1:setRot(0, 0, 90);
		self.line_1:setLocation(88.5, 1.5, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
		self.line_2:SetDimensions(25, 85);
		self.line_2:setScale(1, 1, 1);
		self.line_2:setRot(0, 0, 90);
		self.line_2:setLocation(266.5, 1.5, 0);

		self.avatarItem_2:setLocation(357.5, 0, 0);
	elseif self.style == 4 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
		self.line_1:SetDimensions(25, 125);
		self.line_1:setScale(1, 1, 1);
		self.line_1:setRot(0, 0, 0);
		self.line_1:setLocation(0, -115, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
		self.line_2:SetDimensions(25, 125);
		self.line_2:setScale(1, 1, 1);
		self.line_2:setRot(0, 0, 0);
		self.line_2:setLocation(0, -338, 0);

		self.avatarItem_2:setLocation(0, -449, 0);
		self.firstAvatar:setEnable(true);
		if self.rank == 2 then
			self.firstAvatar:setRank(1);
		else
			self.firstAvatar:setRank(4);
		end
	elseif self.style == 5 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_1:SetDimensions(190, 85);
		self.line_1:setScale(1, 1, 1);
		self.line_1:setRot(180, 0, 0);
		self.line_1:setLocation(83, -97.5, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_2:SetDimensions(190, 85);
		self.line_2:setScale(-1, 1, 1);
		self.line_2:setRot(180, 0, 0);
		self.line_2:setLocation(381, -97.5, 0);

		self.avatarItem_2:setLocation(465, 0, 0);
	elseif self.style == 6 then
		self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_1:SetDimensions(190, 85);
		self.line_1:setScale(1, 1, 1);
		self.line_1:setRot(0, 0, 0);
		self.line_1:setLocation(83, 97.5, 0);

		self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
		self.line_2:SetDimensions(190, 85);
		self.line_2:setScale(-1, 1, 1);
		self.line_2:setRot(0, 0, 0);
		self.line_2:setLocation(381, 97.5, 0);

		self.avatarItem_2:setLocation(465, 0, 0);
	end
end

function Lua_ChampionshipScheduleItem:setData(data)
	self.avatarItem_1:setData(data);
	self.avatarItem_2:setData(data);

	if self.style == 1 or self.style == 2 or self.style == 5 or self.style == 6 then
		self.avatarItem_1:setRole(data.defence_role);
		self.avatarItem_2:setRole(data.attack_role);
		if tonumber(data.win_player_id) > 0 then
			if data.win_player_id == data.attack_role.show_role.id then
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_f");
			else
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_f");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
			end
		else
			self.line_1:setAltas("championship_2", "xui_jys_Progress-_3_b");
			self.line_2:setAltas("championship_2", "xui_jys_Progress-_3_b");
		end
	elseif self.style == 3 then
		self.avatarItem_1:setRole(data.attack_role);
		self.avatarItem_2:setRole(data.defence_role);
		if tonumber(data.win_player_id) > 0 then
			if data.win_player_id == data.attack_role.show_role.id then
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_f");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
			else
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_f");
			end
		else
			self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
			self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
		end
	elseif self.style == 4 then
		self.firstAvatar:setData(data);
		self.avatarItem_1:setRole(data.defence_role);
		self.avatarItem_2:setRole(data.attack_role);
		if tonumber(data.win_player_id) > 0 then
			if data.win_player_id == data.attack_role.show_role.id then
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_f");
				self.firstAvatar:setRole(data.attack_role);
			else
				self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_f");
				self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
				self.firstAvatar:setRole(data.defence_role);
			end
		else
			self.line_1:setAltas("championship_2", "xui_jys_Progress-_4_b");
			self.line_2:setAltas("championship_2", "xui_jys_Progress-_4_b");
			self.firstAvatar:setRole(nil);
		end
	end
end




















Lua_ChampionshipRoleAvatarItem = class("Lua_ChampionshipRoleAvatarItem", Lua_DisplayObject)
function Lua_ChampionshipRoleAvatarItem:ctor(p)
	self:superCall("ctor", p, "ChampionshipRoleAvatarItem_skin");
end

function Lua_ChampionshipRoleAvatarItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self, self.onClick);
end

function Lua_ChampionshipRoleAvatarItem:dispose()
	if self._rankNum then
		self._rankNum:dispose();
		self._rankNum = nil;
	end
	self.data = nil;
	self.roleData = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipRoleAvatarItem.Get:frameIcon()
	if self._frameIcon == nil then
		self._frameIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
		self._frameIcon.siblingIndex = 4;
	end
	return self._frameIcon;
end

function Lua_ChampionshipRoleAvatarItem.Get:rankNum()
	if self._rankNum == nil then
		self._rankNum = Lua_NumberImage.new(self.content);
		self._rankNum.numAtlas = "number";
		self._rankNum.preStr = "xui_jys_number_";
	end
	return self._rankNum;
end

function Lua_ChampionshipRoleAvatarItem:setRank(rank)
	self.rank = rank;
	if self._frameIcon then
		self._frameIcon:setEnable(false);
	end
	if rank == 1 then
		self.frameIcon:setEnable(true);
		self.frameIcon:setAltas("championship_2", "xui_jys_widget_35");
	elseif rank == 2 or rank == 4 then
		self.frameIcon:setEnable(true);
		self.frameIcon:setAltas("championship_2", "xui_jys_widget_36");
	end
	self.icon:setEnable(false);
	self.mask:setEnable(false);
	self.levelBg:setEnable(false);
	self.levelText:setEnable(false);
	self.nameText:setEnable(false);
	if self.rank == 32 then
		self.rankNum.numOffsetX = -20;
		self.rankNum.scaleVal = 0.7;
	elseif self.rank == 16 then
		self.rankNum.numOffsetX = -25;
		self.rankNum.scaleVal = 0.8;
	end
	self.rankNum.num = self.rank;
end

function Lua_ChampionshipRoleAvatarItem:setData(data)
	self.data = data;
end

function Lua_ChampionshipRoleAvatarItem:setRole(data)
	self.roleData = data;
	if data and tonumber(data.show_role.id) > 0 then
		local id = DataCenter.roleData:getDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD, data.show_role.dress_info);
		local vo = DataCenter.roleUtil:getDressUpVoById(id);
		if vo == nil then
			self.icon:setEnable(false);
		else
			self.icon:setEnable(true);
			self.icon:setAltas(vo.atlas, vo.sprite);
		end
		self.mask:setEnable(tonumber(self.data.win_player_id) > 0 and self.data.win_player_id ~= data.show_role.id);
		self.levelBg:setEnable(true);
		self.levelText:setEnable(true);
		self.levelText.text = data.show_role.level;
		self.nameText:setEnable(true);
		self.nameText.text = data.show_role.name;
		self.rankNum.num = nil;
	else
		self.icon:setEnable(false);
		self.mask:setEnable(false);
		self.levelBg:setEnable(false);
		self.levelText:setEnable(false);
		self.nameText:setEnable(false);
		self.rankNum.num = self.rank;
	end
end

function Lua_ChampionshipRoleAvatarItem:onClick(go)
	if self.roleData == nil then
		return;
	end
	if self.roleData.is_robot == 1 then
		OperateAlert.showLangValue(123657);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.roleData.show_role.id, self.roleData.show_role.server_flag);
end