-- 赛程
checkRequire("Lua_ChampionshipScheduleItem");
Lua_ChampionshipSchedulePanel = class("Lua_ChampionshipSchedulePanel", Lua_DisplayObject)
function Lua_ChampionshipSchedulePanel:ctor(p)
	self:superCall("ctor", p, "ChampionshipSchedulePanel_skin");
end

function Lua_ChampionshipSchedulePanel:buildShowItem()
	self:superCall("buildShowItem");
	self.scheduleArr = Array();
	self.checkArr = Array();
	self:addLuaEvent("CHAMPIONSHIP_BATTLE_INFO", self, self.updateServerInfo);

	self.bg:SetDimensions(720, 1099 + self.adaptHeight);
	self.btn_1.clickScale = false;
	self.btn_1:addClickFuntion(self, self.onButtonClick);
	self.btn_2.clickScale = false;
	self.btn_2:addClickFuntion(self, self.onButtonClick);

	self:updateShowInfo();
end

function Lua_ChampionshipSchedulePanel:dispose()
	self:stopTimer();
	if self.groupList ~= nil then
		self.groupList:dispose();
		self.groupList = nil;
	end
	if self.groupInfo ~= nil then
		self.groupInfo:clear();
		self.groupInfo = nil;
	end
	if self.scheduleArr ~= nil then
		self.scheduleArr:dispose();
		self.scheduleArr:clear();
		self.scheduleArr = nil;
	end
	if self.checkArr ~= nil then
		self.checkArr:dispose();
		self.checkArr:clear();
		self.checkArr = nil;
	end
	self.normalInfo = nil;
	self.finalInfo = nil;
	self.fight_info_list = nil;
	self:superCall("dispose");
end

function Lua_ChampionshipSchedulePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.bg:SetDimensions(720, 1099 + adaptHeight);
end

function Lua_ChampionshipSchedulePanel:updateShowInfo()
	local data = DataCenter.championshipData;
	if data.stageInfo ~= nil and DataCenter.roleData:checkInTime(data.startTick, data.endTick) then
		self.scheduleText.text = DataCenter.championshipUtil:getScheduleStr(data.stageInfo.event_type, data.stageInfo.round);
		local serverTime = DataCenter.roleData.serverTime;
		if serverTime < tonumber(data.stageInfo.prepare_end_tick) then -- 准备阶段
			self.stageBg:setEnable(true);
			self.stageText:setEnable(true);
			self.timeText:setEnable(true);
			self.stageText:setLangValue(540033);
			self.endTime = tonumber(data.stageInfo.prepare_end_tick);
			self:startTimer();
			self:onTimer();
		elseif serverTime < tonumber(data.stageInfo.guress_end_tick) then -- 竞猜阶段
			self.stageBg:setEnable(true);
			self.stageText:setEnable(true);
			self.timeText:setEnable(true);
			self.stageText:setLangValue(540034);
			self.endTime = tonumber(data.stageInfo.guress_end_tick);
			self:startTimer();
			self:onTimer();
		elseif serverTime < tonumber(data.stageInfo.fight_end_tick) then -- 战斗阶段
			self.stageBg:setEnable(true);
			self.stageText:setEnable(true);
			self.timeText:setEnable(true);
			self.stageText:setLangValue(540035);
			self.endTime = tonumber(data.stageInfo.fight_end_tick);
			self:startTimer();
			self:onTimer();
		else
			self:stopTimer();
			self.stageBg:setEnable(false);
			self.stageText:setEnable(false);
			self.timeText:setEnable(false);
		end

		if self.bInit ~= true then
			if data.stageInfo.event_type == 3 or (data.stageInfo.event_type == 2 and data.stageInfo.round == 3) then
				self:onSelectIndex(2);
			else
				self:onSelectIndex(1);
			end
		end
	else
		self:stopTimer();
		self.scheduleText:setLangValue(540011);
		self.stageBg:setEnable(false);
		self.stageText:setEnable(false);
		self.timeText:setEnable(false);
		if self.bInit ~= true then
			self:onSelectIndex(1);
		end
	end
	self.bInit = true;

	self.scheduleText:resetSize();
	local posX = self.scheduleText.width / 2 + 33.5
	self.line_1:setLocation(-posX, -202, 0);
	self.line_2:setLocation(posX, -202, 0);
end

function Lua_ChampionshipSchedulePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_ChampionshipMySchedulePanel", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_ChampionshipSchedulePanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ChampionshipSchedulePanel:onTimer()
	local second = self.endTime - DataCenter.roleData.serverTime
	if second > 0 then
		self.timeText.text = Lua_TimeTransform.transSeconds6(second);
	else
		self:stopTimer();
		self.stageBg:setEnable(false);
		self.stageText:setEnable(false);
		self.timeText:setEnable(false);
		self:onRequestInfo();
	end
end

function Lua_ChampionshipSchedulePanel:onButtonClick(go)
	local arr = string.split(go.name, "_");
	self:onSelectIndex(tonumber(arr[2]));
end

function Lua_ChampionshipSchedulePanel:onSelectIndex(index)
	if self.selectedIdx == index then
		return;
	end
	self.selectedIdx = index;

	self.normal_bg:setEnable(index == 1);
	self.final_bg:setEnable(index == 2);
	local info;
	if index == 1 then
		self.btnSelect:setLocation(-160, 209.5);
		if self.normalInfo == nil then
			self.normalInfo = {
				{ rank = 32, style = 1, posX = -278, posY = 459, posX2 = -127, posY2 = 360 },
				{ rank = 32, style = 2, posX = 278, posY = 459, posX2 = 230, posY2 = 360 },
				{ rank = 32, style = 1, posX = -278, posY = 11, posX2 = -127, posY2 = -87 },
				{ rank = 32, style = 2, posX = 278, posY = 11, posX2 = 230, posY2 = -87 },
				{ rank = 16, style = 3, posX = -178, posY = 331, posX2 = 50, posY2 = 360 },
				{ rank = 16, style = 3, posX = -178, posY = -117.5, posX2 = 50, posY2 = -87 },
				{ rank = 8, style = 4, posX = 0, posY = 331, posX2 = 50, posY2 = 135 },
			};
		end
		info = self.normalInfo;
	else
		self.btnSelect:setLocation(160, 209.5);
		if self.finalInfo == nil then
			self.finalInfo = {
				{ rank = 4, style = 5, posX = -232.5, posY = 460, posX2 = 50, posY2 = 360 },
				{ rank = 4, style = 6, posX = -232.5, posY = -244, posX2 = 50, posY2 = -87 },
				{ rank = 2, style = 4, posX = 0, posY = 331, posX2 = 50, posY2 = 135 },
			};
		end
		info = self.finalInfo;
	end

	local len = self.scheduleArr:getSize();
	local dataLen = #info;
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.scheduleArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ChampionshipScheduleItem.new(self.showObject);
				self.scheduleArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(info[i].posX, info[i].posY, 0);
			item:setDefault(info[i].rank, info[i].style);
		end
	end

	self:updateGroup();
end

function Lua_ChampionshipSchedulePanel:updateGroup()
	if self.selectedIdx == 1 then
		if self.groupList == nil then
			self.groupInfo = Array();
			for i = 1, 4 do
				self.groupInfo:add(540069 + i);
			end
			self.groupList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
			self.groupList:setRectAnchor(7);
			self.groupList:setLocation(0, 328.5, 0);
			self.groupList:setButtonCell(Lua_ChampionshipScheduleGroupItem);
			self.groupList:setButtonItem(125, 60);
			self.groupList:setClickCallBack(self, self.onGroupClick);
			self.groupList:setData(self.groupInfo);
		end
		self.btnBg_1:setEnable(true);
		self.groupList:setEnable(true);
		self.groupList.selectedIdx = nil;
		self.groupList:setSelected(1);
	else
		self.btnBg_1:setEnable(false);
		if self.groupList then
			self.groupList:setEnable(false);
		end
		self:onRequestInfo();
	end
end

function Lua_ChampionshipSchedulePanel:onGroupClick(index)
	self.groupIdx = index;
	self:onRequestInfo();
end

function Lua_ChampionshipSchedulePanel:onRequestInfo()
	if self.selectedIdx == 1 then
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sBattleInfo(1, self.groupIdx);
	else
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sBattleInfo(2, 1);
	end
end

function Lua_ChampionshipSchedulePanel:updateServerInfo(msg)
	self:updateShowInfo();
	self.fight_info_list = msg.fight_info_list

	local dataLen = 0;
	if msg.fight_info_list then
		dataLen = #msg.fight_info_list;
		for i = 1, dataLen do
			self.scheduleArr[i]:setData(msg.fight_info_list[i]);
		end
	end

	local info;
	if self.selectedIdx == 1 then
		info = self.normalInfo;
	else
		info = self.finalInfo;
	end
	local len = self.checkArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	for i = 1, maxLen do
		item = self.checkArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = UICreate.createUIAtlasImage(self.content, "championship_2", "xui_jys_button_16", 0, 0, 0, 0);
				self.checkArr:add(item);
			else
				item:setEnable(true);
			end
			item.name = i;
			item:setLocation(info[i].posX2, info[i].posY2, 0);
			item:addClickFuntion(self, self.onCheckInfo);
		end
	end
end

function Lua_ChampionshipSchedulePanel:onCheckInfo(go)
	if self.fight_info_list == nil then
		return;
	end
	local data = self.fight_info_list[tonumber(go.name)];
	Lua_WindowUtil.openWin("Lua_ChampionshipScheduleDetailsWindow", Lua_WinParam.ACTION_OPEN, data);
end





















Lua_ChampionshipScheduleGroupItem = class("Lua_ChampionshipScheduleGroupItem", Lua_ButtonCell)
function Lua_ChampionshipScheduleGroupItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_ChampionshipScheduleGroupItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_006_n", 0, 0, 170, 67);
    self.bg:setScale(0.85, 0.85);
    self.bg:addClickFuntion(self, self.onPressClick);

    self.titleText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 28);
    self.titleText.pivotValue = 4;
    self.titleText.alignmentValue = 4;
    self.titleText.horizontalOverflowValue = 1;
    self.titleText.verticalOverflowValue = 1;
    self.titleText.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_ChampionshipScheduleGroupItem:dispose()
    self:superCall("dispose");
end

function Lua_ChampionshipScheduleGroupItem:setData(data)
    self.titleText:setLangValue(data)
end

function Lua_ChampionshipScheduleGroupItem:setSelected(index)
    if index == self.index then
        self.bg.alpha = 1;
        self.titleText.colorStr = Lua_ColorDefine.transColor("8F5123");
    else
        self.bg.alpha = 0.01;
        self.titleText.colorStr = Lua_ColorDefine.transColor("9F96A1");
    end
end